package router

import (
	"log/slog"
	"net/http"
	"vctp/db"
	"vctp/dist"
	"vctp/server/handler"
	"vctp/server/middleware"
)

func New(logger *slog.Logger, database db.Database, buildTime string, sha1ver string, goVersion string) http.Handler {
	h := &handler.Handler{
		Logger:    logger,
		Database:  database,
		BuildTime: buildTime,
		SHA1Ver:   sha1ver,
		GoVersion: goVersion,
	}

	mux := http.NewServeMux()

	mux.Handle("/assets/", middleware.CacheMiddleware(http.FileServer(http.FS(dist.AssetsDir))))
	mux.HandleFunc("/", h.Home)
	mux.HandleFunc("/api/event/vm/create", h.VmCreate)
	mux.HandleFunc("/api/event/vm/modify", h.VmModify)
	mux.HandleFunc("/api/event/vm/delete", h.VmDelete)
	mux.HandleFunc("/api/import/vm", h.VmImport)

	return middleware.NewLoggingMiddleware(logger, mux)
}
